CF1710C XOR Triangle

的回归。

题目简介

题目名称:

题目来源:

评测链接:https://codeforces.com/problemset/problem/1710/C

形式化题意:求所有三元组 满足 ,且 ,其中 能够构成非退化三角形。对 取模。

数据范围:

考虑将异或视为不进位加法(这里设 为最长边),那么仅有 的情况会有 ,而

我们考虑 ,如果 ,当 时,一定有 ,因此无法构成三角形。

所以我们得出结论,如果存在 则无解。

所以我们数位 按位做即可,时间复杂度

AC Code
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
// ----- Eternally question-----
// Problem: C. XOR Triangle
// Contest: Codeforces - Codeforces Round 810 (Div. 1)
// URL: https://codeforces.com/problemset/problem/1710/C
// Memory Limit: 512 MB
// Time Limit: 4000 ms
// Written by: Eternity
// Time: 2023-10-05 14:28:14
// ----- Endless solution-------

#include<bits/stdc++.h>
#define re register
typedef long long ll;
template<class T>
inline void read(T &x)
{
x=0;
char ch=getchar(),t=0;
while(ch<'0'||ch>'9') t|=ch=='-',ch=getchar();
while(ch>='0'&&ch<='9') x=(x<<3)+(x<<1)+(ch^48),ch=getchar();
if(t) x=-x;
}
template<class T,class ...T1>
inline void read(T &x,T1 &...x1){ read(x),read(x1...); }
template<class T>
inline void write(T x)
{
if(x<0) putchar('-'),x=-x;
if(x>9) write(x/10);
putchar(x%10+'0');
}
template<>
inline void write(bool x){ putchar(x?'1':'0'); }
template<>
inline void write(char c){ putchar(c); }
template<>
inline void write(char *s){ while(*s!='\0') putchar(*s++); }
template<>
inline void write(const char *s){ while(*s!='\0') putchar(*s++); }
template<class T,class ...T1>
inline void write(T x,T1 ...x1){ write(x),write(x1...); }
template<class T>
inline bool checkMax(T &x,T y){ return x<y?x=y,1:0; }
template<class T>
inline bool checkMin(T &x,T y){ return x>y?x=y,1:0; }
const int MAXN=2e5+10;
const int Mod=998244353;
template<class T>
inline void add(T &x,T y){ x=x+y>=Mod?x+y-Mod:x+y; }
char Str[MAXN];
int Dp[MAXN][2][2][2][2][2][2],Nums[MAXN];
int Dfs(int pos,bool lim1,bool lim2,bool lim3,bool ok1,bool ok2,bool ok3)
{
if(!pos) return ok1&ok2&ok3;
int &res=Dp[pos][lim1][lim2][lim3][ok1][ok2][ok3];
if(~res) return res;
res=0;
int num1=lim1?Nums[pos]:1,num2=lim2?Nums[pos]:1,num3=lim3?Nums[pos]:1;
for(int i=0;i<=num1;++i)
for(int j=0;j<=num2;++j)
for(int k=0;k<=num3;++k)
add(res,Dfs(pos-1
,lim1&(i==num1),lim2&(j==num2),lim3&(k==num3)
,ok1|((i^j)+(i^k)>(j^k))
,ok2|((i^k)+(j^k)>(i^j))
,ok3|((i^j)+(j^k)>(i^k))));
return res;
}
int main()
{
// freopen(".in","r",stdin);
// freopen(".out","w",stdout);
std::memset(Dp,-1,sizeof(Dp));
scanf("%s",Str+1);
int Len=std::strlen(Str+1);
for(int i=1;i<=Len;++i) Nums[i]=Str[Len-i+1]-'0';
write(Dfs(Len,1,1,1,0,0,0),'\n');
return 0;
}
/*

*/